#include "avrlibtypes.h"
#include "avrlibdefs.h"
#include "lcdtermo.h"
#include "fontgr.h"
#include "font5x7.h"


u08 ul = 0; 		//underline
u08 sizechar = 7;	//      fontgr.h
u08 fw = FontWidth;
u08 blink = 0;
u08 setblink = 0; 	//    
u08 sel = 0;		//underline

void glcdwrite(u08 by,u08 CS)
{
	if (CS == 0) CS = GLCD_CTRL_CS0;
	if (CS == 1) CS = GLCD_CTRL_CS1;

	outb(GLCD_DATA_DDR, 0xFF);
	outb(GLCD_DATA_PORT, by);
	asm volatile ("nop"); asm volatile ("nop");
	cbi(GLCD_CTRL_PORT, CS);
	asm volatile ("nop"); asm volatile ("nop");
	sbi(GLCD_CTRL_PORT, CS);

};

void glcdclearline (u08 y)
{
  u08 xx;

	
    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW); // Write mode

    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // Command mode
	glcdwrite(y+0xb8,0);
	glcdwrite(0,0);
    sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // data mode
    for(xx=0; xx<hx; xx++) glcdwrite(0,0);

 
    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // Command mode
	glcdwrite(y+0xb8,1);
	glcdwrite(0,1);
    sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // data mode
    for(xx=0; xx<hx; xx++) glcdwrite(0,1);

};

void glcdclear (void)
{
 glcdclearline(0);
 glcdclearline(1);
 glcdclearline(2);
 glcdclearline(3);

};

void lcdinit(void)
{
 cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // Command mode
 cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW); // Write mode

 glcdwrite(0xE2,0);
 glcdwrite(0xEE,0);
 glcdwrite(0xA4,0);
 glcdwrite(0xA9,0);//
 glcdwrite(0xAF,0);
 glcdwrite(0xA0,0);

 glcdwrite(0xE2,1);
 glcdwrite(0xEE,1);
 glcdwrite(0xA4,1);
 glcdwrite(0xA9,1);//
 glcdwrite(0xAF,1);
 glcdwrite(0xA0,1);
 glcdclear();

};

void glcdputtextxy(unsigned char *data,u08 x, u08 y)
{
  u08 i = 0;
  u08 cs = 0;

  cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW); // Write mode 
  cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // Command mode

  glcdwrite(y+0xB8,0); //set y cs0
  glcdwrite(y+0xB8,1); //set y cs1

  glcdwrite(0,1);

  if (x<hx)
        glcdwrite(x,0);
  else  glcdwrite(x-hx,1);
	

  sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);// data mode
  while (*data)
 {

  for(i=0; i<fw; i++)
	{
	  if (x < hx) cs = 0; 
        else cs = 1;  	
    //    if (curfont == 0)
		  glcdwrite(pgm_read_byte(&Font5x7[((*data - 0x20) * fw) + i]) | ul,cs);
 	//	 else 
//		  glcdwrite(pgm_read_byte(&font8r[((*data ) * fw) + i]) | ul,cs);
	  x++;
	}
//////////////////////
  if (x < hx) cs = 0; //   
      else cs = 1;  	
  glcdwrite(0 | ul,cs);
  x++;
////////////////////////
  data++;
 }
};

void glcdsetaddress(u08 x, u08 y)
{	

	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // Command mode
    cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW); // Write mode
	if (x<(lcd_x/2)) {
		glcdwrite(y+0xB8,0);
        glcdwrite(x,0);
	}
	else if (x<lcd_x) {
		glcdwrite(y+0xB8,1);
        glcdwrite(x-(lcd_x/2),1);
	}
};


void glcdwriteimage(u08 grCharIdx,u08 x, u08 y)
{
	u08 idx;
	u08 grLength;
	u16 grStartIdx = 0;
	u08 cs;
	u08 by;

	// get starting index of graphic bitmap
	for(idx=0; idx<grCharIdx; idx++)
	{
		// add this graphic's length to the startIdx
		// to get the startIdx of the next one
		grStartIdx += pgm_read_byte(FontGr+grStartIdx) + 1;
	}
	grLength = pgm_read_byte(FontGr+grStartIdx);

	// write the lines of the desired graphic to the display

  	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RW); // Write mode 
  	cbi(GLCD_CTRL_PORT, GLCD_CTRL_RS); // Command mode

  	glcdwrite(y+0xB8,0); //set y cs0
  	glcdwrite(y+0xB8,1); //set y cs1

  	glcdwrite(0,1);

  	if (x<hx)
        glcdwrite(x,0);
  	else  glcdwrite(x-hx,1);
  	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);// data mode

	for(idx=0; idx<grLength; idx++)
	{
		// write the line
		if (x < hx) cs = 0; 
        	else cs = 1;  	
		by = pgm_read_byte(FontGr+(grStartIdx+1)+idx);
		if (setblink)
		{
		  if (blink == 0) by = 0;
		};

		glcdwrite(by | ul,cs);
		x++;
	}
};

void writebigdigit(u08 d, u08 x, u08 y)
{
 u08 id;
 id = d * 2;
 if (id > 100) id = 53; //
 glcdwriteimage(id,x,y);
 glcdwriteimage(id+1,x,y+1);
};

void writesquare(u08 side,u08 x, u08 y, u08 viz)
{
 u08 cs;
 u08 us = 0xFF;
 u08 ds = 0x1F;


 if (viz > 0) 
  {
   us = 0xFF;
   ds = 0x1F;
  }
    else 
  {
   us = 0;
   ds = 0;
  };
 if (x < hx) cs = 0; 
   	else cs = 1;  	

  if (side == 0) //left
  	{
	glcdsetaddress(x-1,y); //as
 	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);// data mode
 	glcdwrite(us,cs);
 	glcdsetaddress(x-1,y+1); //as
 	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);// data mode
 	glcdwrite(ds,cs);
    };
  if (side == 1) //right
  	{
	glcdsetaddress(x+sizechar,y); //as
 	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);// data mode
 	glcdwrite(us,cs);
 	glcdsetaddress(x+sizechar,y+1); //as
 	sbi(GLCD_CTRL_PORT, GLCD_CTRL_RS);// data mode
 	glcdwrite(ds,cs);
	};

};

void write_abc(u08 c,u08 x, u08 y, u08 p)
{ u08 v;
 
 
 v = 0;
 if ((p > 0) & (c == p)) 
  {
    sel = 2; v = 1;
  } else sel = 0;

 writesquare(0,x,y,v);
 if (sel == 0) ul = 0;
 if (sel != 0) ul = 1;
 glcdwriteimage(22+(c-1) * 2,x,y);
 if (sel != 0) ul = 0x10; 
 glcdwriteimage(23+(c-1) * 2,x,y+1);
 writesquare(1,x,y,v);
 sel = 0;
 ul = 0;
};

void writesmalldigit(u08 d, u08 x, u08 y, u08 s)
{
 // sel = 0 - not 1 left 2 midl 3 right  
 u08 id;

 
 if (s == 1)
   writesquare(0,x,y,1);

 if (s == 3)
 {
 	glcdsetaddress(x+sizechar,y); //as
	writesquare(1,x,y,1);
  };

if (s == 0)
 {
   writesquare(0,x,y,0);
	glcdsetaddress(x+sizechar,y); //as
	writesquare(1,x,y,0);
	ul = 0;
 };

 
 id = (d * 2) + 28;
// if (id > 60) id = 50;//  .  fontgr
 if (s != 0) ul = 1;
 glcdwriteimage(id,x,y);
 if (s != 0) ul = 0x10;
 glcdwriteimage(id+1,x,y+1);
 s = 0;
 ul = 0;
};


